#CC-RL Compiler RL78 Assembler Source
#@  CC-RL Version : V1.08.00 [28 Nov 2018]
#@  Commmand :
#@   -cpu=S1
#@   -obj_path=.\obj\
#@   -asm_path=.\obj\
#@   -dev=C:\Program Files (x86)\Renesas Electronics\Applilet EZ PL for RL78 V2.20\Tools\BIN\..\..\Tools\DEV\DR5F10Y47.DVF
#@   -c
#@   -I C:\Program Files (x86)\Renesas Electronics\CS+\CC\CC-RL\V1.08.00\inc,.\include
#@   -Osize
#@   -pass_source
#@   src\panel.c
#@  compiled at Tue Jun 18 19:05:19 2019

	.EXTERN _fTrg10ms
	.PUBLIC _I_04
	.PUBLIC _F0304
	.PUBLIC _F0404
	.PUBLIC _F1504
	.PUBLIC _F1506
	.PUBLIC _F1509
	.PUBLIC _panel_init0
	.EXTERN _DGIN_Initialize
	.EXTERN _DGIN_Counter
	.EXTERN _PWM_Initialize
	.PUBLIC _panel
	.EXTERN _DGIN_Counter_Clear
	.EXTERN _PWM_Counter_Clear
	.EXTERN _DGIN_getValue
	.EXTERN _MOV1_
	.EXTERN _PANEL_CPL_PWM
	.EXTERN _PWM_Param
	.EXTERN _PWM_Out_Proc
	.EXTERN _DGOUT_setValue

	.SECTION .text,TEXT
_panel_init0:
	.STACK _panel_init0 = 4
	;***        1 : /*******************************************************************************
	;***        2 : * DISCLAIMER
	;***        3 : * This software is supplied by Renesas Electronics Corporation and is only
	;***        4 : * intended for use with Renesas products. No other uses are authorized. This
	;***        5 : * software is owned by Renesas Electronics Corporation and is protected under
	;***        6 : * all applicable laws, including copyright laws.
	;***        7 : * THIS SOFTWARE IS PROVIDED "AS IS" AND RENESAS MAKES NO WARRANTIES REGARDING
	;***        8 : * THIS SOFTWARE, WHETHER EXPRESS, IMPLIED OR STATUTORY, INCLUDING BUT NOT
	;***        9 : * LIMITED TO WARRANTIES OF MERCHANTABILITY, FITNESS FOR A PARTICULAR PURPOSE
	;***       10 : * AND NON-INFRINGEMENT. ALL SUCH WARRANTIES ARE EXPRESSLY DISCLAIMED.
	;***       11 : * TO THE MAXIMUM EXTENT PERMITTED NOT PROHIBITED BY LAW, NEITHER RENESAS
	;***       12 : * ELECTRONICS CORPORATION NOR ANY OF ITS AFFILIATED COMPANIES SHALL BE LIABLE
	;***       13 : * FOR ANY DIRECT, INDIRECT, SPECIAL, INCIDENTAL OR CONSEQUENTIAL DAMAGES FOR
	;***       14 : * ANY REASON RELATED TO THIS SOFTWARE, EVEN IF RENESAS OR ITS AFFILIATES HAVE
	;***       15 : * BEEN ADVISED OF THE POSSIBILITY OF SUCH DAMAGES.
	;***       16 : * Renesas reserves the right, without notice, to make changes to this software
	;***       17 : * and to discontinue the availability of this software. By using this software,
	;***       18 : * you agree to the additional terms and conditions found by accessing the
	;***       19 : * following link:
	;***       20 : * http://www.renesas.com/disclaimer
	;***       21 : *
	;***       22 : * Copyright (C) 2016 Renesas Electronics Corporation. All rights reserved.
	;***       23 : *******************************************************************************/
	;***       24 : 
	;***       25 : /*******************************************************************************
	;***       26 : * File Name    : panel.c
	;***       27 : * Version      : Applilet EZ PL for RL78
	;***       28 : * Device(s)    : R5F10Y14,R5F10Y16,R5F10Y17,R5F10Y44,R5F10Y46,R5F10Y47
	;***       29 : * Tool-Chain   : CC-RL
	;***       30 : * Description  : This file implements main function.
	;***       31 : * Creation Date: 2016/09/14
	;***       32 : *******************************************************************************/
	;***       33 : 
	;***       34 : /*******************************************************************************
	;***       35 : Includes <System Includes> , "Project Includes"
	;***       36 : *******************************************************************************/
	;***       37 : #include "sfr.h"
	;***       38 : #include "common.h"
	;***       39 : #include "config.h"
	;***       40 : #include "panel.h"
	;***       41 : 
	;***       42 : /*******************************************************************************
	;***       43 : Exported global variables and functions (to be accessed by other files)
	;***       44 : *******************************************************************************/
	;***       45 : /*--- Variable declaration ---*/
	;***       46 : 	UCHAR I_04;
	;***       47 : 	UCHAR F0304 = 0;
	;***       48 : 	UCHAR F0404 = 0;
	;***       49 : 	UCHAR F1504 = 0;
	;***       50 : 	UCHAR F1506 = 0;
	;***       51 : 	UCHAR F1509 = 0;
	;***       52 : 
	;***       53 : /*----------------------------*/
	;***       54 : 
	;***       55 : void panel_init0(void)
	;***       56 : {
	;***       57 : 
	;***       58 : 	DGIN_INIT0(0);
	clrb a
	call !_DGIN_Initialize
	call !_DGIN_Counter
	;***       59 : 	PWM_INIT0( 4,440 );
	clrw ax
	movw de, ax
	movw bc, #0x01B8
	mov a, #0x04
	call !_PWM_Initialize
	;***       60 : 	PWM_INIT0( 5,440 );
	clrw ax
	movw de, ax
	movw bc, #0x01B8
	mov a, #0x05
	br !_PWM_Initialize
_panel:
	.STACK _panel = 4
	;***       61 : }
	;***       62 : 
	;***       63 : void panel(void)
	;***       64 : {
	;***       65 : 	DGIN_INIT;
	call !_DGIN_Counter_Clear
	;***       66 : 	PWM_INIT;
	call !_PWM_Counter_Clear
	;***       67 : 
	;***       68 : 	DGIN_PROC( I_04,137, LOW,0,fTrg10ms);
	mov c, _fTrg10ms
	movw ax, #0x8900
	call !_DGIN_getValue
	and a, #0x01
	xor a, #0x01
	mov !LOWW(_I_04), a
	call !_DGIN_Counter
	call !__CommonCode@1
	;***       69 : 	F0304 = MOV1_( I_04 );
	mov !LOWW(_F0304), a
	;***       70 : 	PANEL_CPL_PWM( F0304,&F0404 );
	movw bc, #LOWW(_F0404)
	call !_PANEL_CPL_PWM
	call !__CommonCode@1
	;***       71 : 	F1504 = MOV1_( I_04 );
	mov !LOWW(_F1504), a
	call !__CommonCode@1
	;***       72 : 	F1506 = MOV1_( I_04 );
	mov !LOWW(_F1506), a
	;***       73 : 	F1509 = MOV1_( F0404 );
	mov a, !LOWW(_F0404)
	call !_MOV1_
	mov !LOWW(_F1509), a
	;***       74 : 	PWM_PARAM( 50,F1504 );
	mov x, !LOWW(_F1504)
	call !__CommonCode@0
	;***       75 : 	PWM_PROC;
	;***       76 : 	PWM_PARAM( 50,F1506 );
	mov x, !LOWW(_F1506)
	call !__CommonCode@0
	;***       77 : 	PWM_PROC;
	;***       78 : 	DGOUT_PROC( 0, F1509, LOW );
	mov x, !LOWW(_F1509)
	clrb c
	clrb a
	br !_DGOUT_setValue
__CommonCode@0:
	.STACK __CommonCode@0 = 4
	mov a, #0x32
	call !_PWM_Param
	call !_PWM_Out_Proc
	ret
__CommonCode@1:
	.STACK __CommonCode@1 = 4
	mov a, !LOWW(_I_04)
	call !_MOV1_
	ret
	;***       79 : }
	.SECTION .bss,BSS
_I_04:
	.DS (1)
	.SECTION .data,DATA
_F0304:
	.DS (1)
_F0404:
	.DS (1)
_F1504:
	.DS (1)
_F1506:
	.DS (1)
_F1509:
	.DS (1)
