#CC-RL Compiler RL78 Assembler Source
#@  CC-RL Version : V1.08.00 [28 Nov 2018]
#@  Commmand :
#@   -cpu=S1
#@   -obj_path=.\obj\
#@   -asm_path=.\obj\
#@   -dev=C:\Program Files (x86)\Renesas Electronics\Applilet EZ PL for RL78 V2.20\Tools\BIN\..\..\Tools\DEV\DR5F10Y47.DVF
#@   -c
#@   -I C:\Program Files (x86)\Renesas Electronics\CS+\CC\CC-RL\V1.08.00\inc,.\include
#@   -Osize
#@   -pass_source
#@   src\pwm.c
#@  compiled at Tue Jun 18 19:05:25 2019

	.PUBLIC _tblgPWM
	.PUBLIC _ucgPWM_Cnt
	.PUBLIC _ucLoopCount
	.PUBLIC _ulFprs
	.PUBLIC _ulDivideWork
	.PUBLIC _ulRoundWork
	.PUBLIC _ulTDR00
	.PUBLIC _PWM_CH1_Init
	.PUBLIC _PWM_Param
	.PUBLIC _PWM_Out_CH1
	.PUBLIC _PWM_Calc_Duty
	.PUBLIC _PWM_Counter_Clear
	.PUBLIC _PWM_Initialize
	.PUBLIC _PWM_Out_Proc
	.PUBLIC _PWM_CH0_Init
	.PUBLIC _PWM_CH2_Init
	.PUBLIC _PWM_CH3_Init
	.PUBLIC _PWM_Out_CH2
	.PUBLIC _PWM_Out_CH3

	.SECTION .text,TEXT
_PWM_CH1_Init:
	.STACK _PWM_CH1_Init = 4
	;***        1 : /*******************************************************************************
	;***        2 : * DISCLAIMER
	;***        3 : * This software is supplied by Renesas Electronics Corporation and is only
	;***        4 : * intended for use with Renesas products. No other uses are authorized. This
	;***        5 : * software is owned by Renesas Electronics Corporation and is protected under
	;***        6 : * all applicable laws, including copyright laws.
	;***        7 : * THIS SOFTWARE IS PROVIDED "AS IS" AND RENESAS MAKES NO WARRANTIES REGARDING
	;***        8 : * THIS SOFTWARE, WHETHER EXPRESS, IMPLIED OR STATUTORY, INCLUDING BUT NOT
	;***        9 : * LIMITED TO WARRANTIES OF MERCHANTABILITY, FITNESS FOR A PARTICULAR PURPOSE
	;***       10 : * AND NON-INFRINGEMENT. ALL SUCH WARRANTIES ARE EXPRESSLY DISCLAIMED.
	;***       11 : * TO THE MAXIMUM EXTENT PERMITTED NOT PROHIBITED BY LAW, NEITHER RENESAS
	;***       12 : * ELECTRONICS CORPORATION NOR ANY OF ITS AFFILIATED COMPANIES SHALL BE LIABLE
	;***       13 : * FOR ANY DIRECT, INDIRECT, SPECIAL, INCIDENTAL OR CONSEQUENTIAL DAMAGES FOR
	;***       14 : * ANY REASON RELATED TO THIS SOFTWARE, EVEN IF RENESAS OR ITS AFFILIATES HAVE
	;***       15 : * BEEN ADVISED OF THE POSSIBILITY OF SUCH DAMAGES.
	;***       16 : * Renesas reserves the right, without notice, to make changes to this software
	;***       17 : * and to discontinue the availability of this software. By using this software,
	;***       18 : * you agree to the additional terms and conditions found by accessing the
	;***       19 : * following link:
	;***       20 : * http://www.renesas.com/disclaimer
	;***       21 : *
	;***       22 : * Copyright (C) 2016 Renesas Electronics Corporation. All rights reserved.
	;***       23 : *******************************************************************************/
	;***       24 : 
	;***       25 : /*******************************************************************************
	;***       26 : * File Name    : pwm.c
	;***       27 : * Version      : Applilet EZ PL for RL78
	;***       28 : * Device(s)    : R5F10Y14,R5F10Y16,R5F10Y17,R5F10Y44,R5F10Y46,R5F10Y47
	;***       29 : * Tool-Chain   : CC-RL
	;***       30 : * Description  : This file implements main function.
	;***       31 : * Creation Date: 2016/09/14
	;***       32 : *******************************************************************************/
	;***       33 : 
	;***       34 : /*******************************************************************************
	;***       35 : Includes <System Includes> , "Project Includes"
	;***       36 : *******************************************************************************/
	;***       37 : #include "sfr.h"
	;***       38 : #include "common.h"
	;***       39 : #include "config.h"
	;***       40 : #include "pwm.h"
	;***       41 : 
	;***       42 : #if defined PWM_USED
	;***       43 : /*******************************************************************************
	;***       44 : Macro definitions
	;***       45 : *******************************************************************************/
	;***       46 : /*  PORT Assignment		*/
	;***       47 : #ifdef __CCRL__
	;***       48 : #define	PORT_PWM_CH1	P0_bit.no4
	;***       49 : #define	PORT_PWM_CH2	P0_bit.no5
	;***       50 : #define	PORT_PWM_CH3	P0_bit.no7
	;***       51 : 
	;***       52 : #else
	;***       53 : #error "undefined compiler"
	;***       54 : #endif
	;***       55 : 
	;***       56 : /*******************************************************************************
	;***       57 : Typedef definitions
	;***       58 : *******************************************************************************/
	;***       59 : 
	;***       60 : /*******************************************************************************
	;***       61 : Imported global variables and functions (from other files)
	;***       62 : *******************************************************************************/
	;***       63 : 
	;***       64 : /*******************************************************************************
	;***       65 : Exported global variables and functions (to be accessed by other files)
	;***       66 : *******************************************************************************/
	;***       67 : /*  Structure Definition	*/
	;***       68 : #ifdef __CCRL__
	;***       69 : __saddr PWM_TBL tblgPWM[PWM_USED];
	;***       70 : __saddr UCHAR	ucgPWM_Cnt = 0;
	;***       71 : __saddr UCHAR	ucLoopCount;
	;***       72 : __saddr ULONG	ulFprs;
	;***       73 : __saddr ULONG	ulDivideWork;
	;***       74 : __saddr ULONG	ulRoundWork;
	;***       75 : __saddr ULONG	ulTDR00;
	;***       76 : 
	;***       77 : #else
	;***       78 : #error "undefined compiler"
	;***       79 : #endif
	;***       80 : 
	;***       81 : /*	Function Prototype	*/
	;***       82 : void PWM_CH0_Init( ULONG Freq );
	;***       83 : void PWM_CH1_Init( ULONG Freq );
	;***       84 : void PWM_CH2_Init( ULONG Freq );
	;***       85 : void PWM_CH3_Init( ULONG Freq );
	;***       86 : void PWM_Out_CH1( void );
	;***       87 : void PWM_Out_CH2( void );
	;***       88 : void PWM_Out_CH3( void );
	;***       89 : UCHAR PWM_Calc_Duty( UCHAR regTDR00L );
	;***       90 : 
	;***       91 : /*******************************************************************************
	;***       92 : Private variables and functions
	;***       93 : *******************************************************************************/
	;***       94 : 
	;***       95 : /*******************************************************************************
	;***       96 : * Function Name: PWM_CH1_Init
	;***       97 : * Description  : initializing the PWM output that uses the Timer Array Unit(Cannel1).
	;***       98 : * Arguments    : Freq    ... setting frequency
	;***       99 : * Return Value : none
	;***      100 : ********************************************************************************/
	;***      101 : void PWM_CH1_Init( ULONG Freq )
	call !__CommonCode@10
	;***      102 : {
	;***      103 : #if ( !defined(_IARCOMPILER) && !defined(__GCC__) ) || defined(_IARCOMPILER) || ( defined(__GCC__) && defined(PWM_CH1_USED) )
	;***      104 : 	/* Enables timer array unit input clock supply(TAU0EN=1) */
	;***      105 : 	PER0 |= 0x01;
	;***      106 : 
	;***      107 : 	TPS0  = 0x00;
	mov [hl+0xC6], #0x00
	;***      108 : 	TTH0 |= 0x02;			/* TTH01 = 1 */
	mov a, [hl+0xC5]
	set1 a.1
	mov [hl+0xC5], a
	;***      109 : 	TT0  |= 0x03;			/* TT00 = 1, TT01 = 1 */
	mov a, [hl+0xC4]
	or a, #0x03
	call !__CommonCode@9
	movw de, #0x0192
	call !__CommonCode@8
	;***      110 : 	
	;***      111 : 	PWM_CH0_Init(Freq);
	;***      112 : 
	;***      113 : 	TMR01H = 0x04;
	;***      114 : 	TMR01L = 0x09;
	;***      115 : 	TOM0 |= 0x02;			/* TOM01 = 1 */
	mov a, [de+0x2C]
	set1 a.1
	mov [de+0x2C], a
	;***      116 : 	TOL0 &= (UCHAR)~0x02;	/* TOL01 = 0 */
	mov a, [de+0x2A]
	clr1 a.1
	mov [de+0x2A], a
	;***      117 : 	TO0  &= (UCHAR)~0x02;	/* TO01  = 0 */
	mov a, [de+0x26]
	clr1 a.1
	mov [de+0x26], a
	;***      118 : 	TOE0 &= (UCHAR)~0x02;	/* TOE01 = 0 */
	mov a, [de+0x28]
	clr1 a.1
	mov [de+0x28], a
	call !__CommonCode@7
	;***      119 : 
	;***      120 : 	IF0L &= (UCHAR)~0x80;	/* TMIF00 = 0 */
	;***      121 : 	MK0L &= (UCHAR)~0x80;	/* TMMK00 = 0 */
	;***      122 : 	TS0  |= 0x01;			/* TS00   = 1(timer start) */
	mov a, [de+0x20]
	set1 a.0
	mov [de+0x20], a
	ret
_PWM_Param:
	.STACK _PWM_Param = 4
	;***      123 : #endif /* end of ( !defined(_IARCOMPILER) && !defined(__GCC__) ) || defined(_IARCOMPILER) || ( defined(__GCC__) && defined(PWM_CH1_USED) ) */
	;***      124 : }
	;***      125 : 
	;***      126 : /*******************************************************************************
	;***      127 : * Function Name: PWM_Param
	;***      128 : * Description  : duty setting.
	;***      129 : * Arguments    : Duty ... duty ratio
	;***      130 : *                In   ... enable/disable
	;***      131 : * Return Value : none
	;***      132 : ********************************************************************************/
	;***      133 : void PWM_Param( UCHAR Duty, UCHAR In )
	mov h, a
	;***      134 : {
	;***      135 : 	if (In == 1){
	dec x
	bnz $.BB@LABEL@2_5
.BB@LABEL@2_1:	; if_then_bb
	;***      136 : 		if (tblgPWM[ucgPWM_Cnt].Input == LOW){
	mov a, _ucgPWM_Cnt
	shrw ax, 8+0x00000
	shlw ax, 0x02
	movw bc, ax
	addw ax, #LOWW(_tblgPWM+0x00001)
	movw de, ax
	mov a, [de]
	cmp0 a
	bnz $.BB@LABEL@2_3
.BB@LABEL@2_2:	; if_then_bb13
	mov a, h
	;***      137 : 			tblgPWM[ucgPWM_Cnt].SetDuty = Duty;
	mov LOWW(_tblgPWM+0x00002)[bc], a
	;***      138 : 			tblgPWM[ucgPWM_Cnt].Input = 1;
	mov [de+0x00], #0x01
	ret
.BB@LABEL@2_3:	; if_else_bb
	;***      139 : 
	;***      140 : 		}else if (tblgPWM[ucgPWM_Cnt].Input == HIGH){
	dec a
	sknz
.BB@LABEL@2_4:	; if_then_bb32
	;***      141 : 			tblgPWM[ucgPWM_Cnt].SetDuty = 0;
	mov LOWW(_tblgPWM+0x00002)[bc], #0x00
.BB@LABEL@2_5:	; return
	ret
_PWM_Out_CH1:
	.STACK _PWM_Out_CH1 = 6
	;***      142 : 		}
	;***      143 : 	}
	;***      144 : }
	;***      145 : 
	;***      146 : /*******************************************************************************
	;***      147 : * Function Name: PWM_Out_CH1
	;***      148 : * Description  : PWM that uses the Timer Array Unit(Cannel1) output.
	;***      149 : * Arguments    : none
	;***      150 : * Return Value : none
	;***      151 : ********************************************************************************/
	;***      152 : void PWM_Out_CH1( void )
	push hl
	call !__CommonCode@5
	;***      153 : {
	;***      154 : #if ( !defined(_IARCOMPILER) && !defined(__GCC__) ) || defined(_IARCOMPILER) || ( defined(__GCC__) && defined(PWM_CH1_USED) )
	;***      155 : 	UCHAR	ucreg;
	;***      156 : 	UCHAR	regTDR01L;
	;***      157 : 
	;***      158 : 	if (tblgPWM[ucgPWM_Cnt].Input == HIGH){
	bnz $.BB@LABEL@3_6
.BB@LABEL@3_1:	; if_then_bb
	movw ax, bc
	call !__CommonCode@0
	;***      159 : 		if (tblgPWM[ucgPWM_Cnt].SetDuty != tblgPWM[ucgPWM_Cnt].OutDuty){
	cmp a, [hl]
	bz $.BB@LABEL@3_9
.BB@LABEL@3_2:	; if_then_bb23
	;***      160 : 			switch (tblgPWM[ucgPWM_Cnt].SetDuty){
	cmp0 a
	bz $.BB@LABEL@3_8
.BB@LABEL@3_3:	; if_then_bb23
	cmp a, #0x64
	bz $.BB@LABEL@3_5
.BB@LABEL@3_4:	; switch_clause_bb48
	call !__CommonCode@4
	;***      161 : 				case 0:
	;***      162 : 					TT0  |= 0x02;			/* TT01  = 1(timer stop) */
	;***      163 : 					TOE0 &= (UCHAR)~0x02;	/* TOE01 = 0 */
	;***      164 : 					PORT_PWM_CH1 = LOW;
	;***      165 : 					break;
	;***      166 : 				case 100:
	;***      167 : 					TT0  |= 0x02;			/* TT01  = 1(timer stop) */
	;***      168 : 					TOE0 &= (UCHAR)~0x02;	/* TOE01 = 0 */
	;***      169 : 					PORT_PWM_CH1 = HIGH;
	;***      170 : 					break;
	;***      171 : 				default:
	;***      172 : 					ucreg  = TDR00L;
	;***      173 : 					regTDR01L = PWM_Calc_Duty(ucreg);
	;***      174 : 					TT0  |= 0x02;			/* TT01  = 1(timer stop) */
	set1 a.1
	mov [de+0x02], a
	;***      175 : 					TDR01H = 0x00;
	clrb 0xFFF1B
	mov a, x
	;***      176 : 					TDR01L = regTDR01L;
	mov 0xFFF1A, a
	;***      177 : 					PORT_PWM_CH1 = LOW;
	clr1 0xFFF00.4
	;***      178 : 					TOE0 |= 0x02;			/* TOE01 = 1 */
	mov a, [de+0x08]
	set1 a.1
	mov [de+0x08], a
	;***      179 : 					TS0  |= 0x02;			/* TS01  = 1(timer start) */
	mov a, [de]
	set1 a.1
	mov [de], a
	br $.BB@LABEL@3_9
.BB@LABEL@3_5:	; switch_clause_bb38
	call !__CommonCode@12
	set1 0xFFF00.4
	br $.BB@LABEL@3_9
.BB@LABEL@3_6:	; if_else_bb
	;***      180 : 					break;
	;***      181 : 			}
	;***      182 : 		}
	;***      183 : 
	;***      184 : 	}else if (tblgPWM[ucgPWM_Cnt].Input == LOW){
	cmp0 a
	bnz $.BB@LABEL@3_9
.BB@LABEL@3_7:	; if_then_bb74
	call !__CommonCode@3
.BB@LABEL@3_8:	; switch_clause_bb
	call !__CommonCode@12
	clr1 0xFFF00.4
.BB@LABEL@3_9:	; if_break_bb88
	call !__CommonCode@1
	call !__CommonCode@0
	;***      185 : 		tblgPWM[ucgPWM_Cnt].SetDuty = 0;
	;***      186 : 		TT0  |= 0x02;						/* TT01  = 1(timer stop) */
	;***      187 : 		TOE0 &= (UCHAR)~0x02;				/* TOE01 = 0 */
	;***      188 : 		PORT_PWM_CH1 = LOW;
	;***      189 : 	}
	;***      190 : 	tblgPWM[ucgPWM_Cnt].OutDuty = tblgPWM[ucgPWM_Cnt].SetDuty;
	mov [hl], a
	pop hl
	ret
_PWM_Calc_Duty:
	.STACK _PWM_Calc_Duty = 14
	;***      191 : #endif /* end of ( !defined(_IARCOMPILER) && !defined(__GCC__) ) || defined(_IARCOMPILER) || ( defined(__GCC__) && defined(PWM_CH1_USED) ) */
	;***      192 : }
	;***      193 : 
	;***      194 : /*******************************************************************************
	;***      195 : * Function Name: PWM_Calc_Duty
	;***      196 : * Description  : The register setting value corresponding to the duty is calculated.
	;***      197 : * Arguments    : regTDR00L ... TDR0nL setting value
	;***      198 : *                Duty    ... duty ratio
	;***      199 : * Return Value : CMP1n setting value
	;***      200 : ********************************************************************************/
	;***      201 : UCHAR PWM_Calc_Duty( UCHAR regTDR00L )
	subw sp, #0x06
	;***      202 : {
	;***      203 : 	ULONG	ulwork1 = 0;
	;***      204 : 	UCHAR	ucwork2 = 0;
	;***      205 : 	UCHAR	ucwork3 = 0;
	;***      206 : 	
	;***      207 : 	ulwork1 = regTDR00L;
	shrw ax, 8+0x00000
	;***      208 : 	ulwork1 = (ulwork1 + 1) * tblgPWM[ucgPWM_Cnt].SetDuty;
	addw ax, #0x0001
	movw bc, ax
	clrw ax
	sknc
.BB@LABEL@4_1:	; entry
	incw ax
.BB@LABEL@4_2:	; entry
	push ax
	push bc
	call !__CommonCode@1
	addw ax, #LOWW(_tblgPWM+0x00002)
	movw de, ax
	clrw bc
	mov a, [de]
	shrw ax, 8+0x00000
	call !!__COM_lmul
	movw [sp+0x04], ax
	movw ax, bc
	movw [sp+0x06], ax
	addw sp, #0x04
	clrw ax
	;***      209 : 	ucwork2 = (UCHAR)(ulwork1 % 100);
	push ax
	movw ax, #0x0064
	push ax
	movw ax, [sp+0x04]
	call !!__COM_ulrem
	movw [sp+0x08], ax
	addw sp, #0x04
	clrw ax
	;***      210 : 	ucwork3 = (UCHAR)(ulwork1 / 100);
	push ax
	movw ax, #0x0064
	push ax
	movw ax, [sp+0x06]
	movw bc, ax
	movw ax, [sp+0x04]
	call !!__COM_uldiv
	addw sp, #0x04
	movw bc, ax
	movw ax, [sp+0x04]
	mov a, x
	;***      211 : 	
	;***      212 : 	if (ucwork2 >= 50)	ucwork3 ++;
	cmp a, #0x32
	mov a, c
	skc
.BB@LABEL@4_3:	; if_then_bb
	inc a
.BB@LABEL@4_4:	; if_break_bb
	;***      213 : 	
	;***      214 : 	if (ucwork3 == 0)	ucwork3 ++;
	cmp0 a
	sknz
.BB@LABEL@4_5:	; if_then_bb28
	inc a
.BB@LABEL@4_6:	; if_break_bb31
	addw sp, #0x06
	ret
_PWM_Counter_Clear:
	.STACK _PWM_Counter_Clear = 4
	;***      215 : 	
	;***      216 : 	return ucwork3;
	;***      217 : }
	;***      218 : 
	;***      219 : /*******************************************************************************
	;***      220 : * Function Name: PWM_Counter_Clear
	;***      221 : * Description  : PWM Panel Counter Clear.
	;***      222 : * Arguments    : none
	;***      223 : * Return Value : none
	;***      224 : ********************************************************************************/
	;***      225 : void PWM_Counter_Clear( void )
	;***      226 : {
	;***      227 : 	ucgPWM_Cnt = 0;
	clrb _ucgPWM_Cnt
	ret
_PWM_Initialize:
	.STACK _PWM_Initialize = 10
	;***      228 : }
	;***      229 : 
	;***      230 : /*******************************************************************************
	;***      231 : * Function Name: PWM_Initialize
	;***      232 : * Description  : PWM Initialize Process.
	;***      233 : * Arguments    : OutPort
	;***      234 : *                Freq
	;***      235 : * Return Value : none
	;***      236 : ********************************************************************************/
	;***      237 : void PWM_Initialize( UCHAR OutPort, ULONG Freq )
	push ax
	push hl
	push bc
	pop hl
	push de
	pop bc
	call !__CommonCode@1
	;***      238 : {
	;***      239 : 	tblgPWM[ucgPWM_Cnt].Input = 0;
	addw ax, #LOWW(_tblgPWM)
	movw [sp+0x00], ax
	;***      240 : 	tblgPWM[ucgPWM_Cnt].SetDuty = 0;
	incw ax
	movw de, ax
	movw ax, [sp+0x00]
	mov [de+0x00], #0x00
	incw de
	;***      241 : 	tblgPWM[ucgPWM_Cnt].OutDuty = 0;
	addw ax, #0x0003
	mov [de+0x00], #0x00
	movw de, ax
	mov [de+0x00], #0x00
	pop de
	push de
	mov a, [sp+0x03]
	;***      242 : 	tblgPWM[ucgPWM_Cnt].Port = OutPort;
	mov [de], a
	;***      243 : 
	;***      244 : 	switch (OutPort){		/* P04,P05,P07 comes without fail. */
	add a, #0xFC
	bz $.BB@LABEL@6_4
.BB@LABEL@6_1:	; entry
	dec a
	bz $.BB@LABEL@6_5
.BB@LABEL@6_2:	; entry
	cmp a, #0x02
	bnz $.BB@LABEL@6_6
.BB@LABEL@6_3:	; switch_clause_bb22
	;***      245 : 		case 4:
	;***      246 : 			PWM_CH1_Init(Freq);
	;***      247 : 			break;
	;***      248 : 		case 5:
	;***      249 : 			PWM_CH2_Init(Freq);
	;***      250 : 			break;
	;***      251 : 		case 7:
	;***      252 : 			PWM_CH3_Init(Freq);
	movw ax, hl
	call !_PWM_CH3_Init
	br $.BB@LABEL@6_6
.BB@LABEL@6_4:	; switch_clause_bb
	movw ax, hl
	call !_PWM_CH1_Init
	br $.BB@LABEL@6_6
.BB@LABEL@6_5:	; switch_clause_bb20
	movw ax, hl
	call !_PWM_CH2_Init
.BB@LABEL@6_6:	; switch_break_bb
	;***      253 : 			break;
	;***      254 : 	}
	;***      255 : 
	;***      256 : 	ucgPWM_Cnt++;
	add _ucgPWM_Cnt, #0x01
	addw sp, #0x04
	ret
_PWM_Out_Proc:
	.STACK _PWM_Out_Proc = 4
	;***      257 : }
	;***      258 : 
	;***      259 : /*******************************************************************************
	;***      260 : * Function Name: PWM_Out_Proc
	;***      261 : * Description  : PWM Out Processing.
	;***      262 : * Arguments    : none
	;***      263 : * Return Value : none
	;***      264 : ********************************************************************************/
	;***      265 : void PWM_Out_Proc( void )
	call !__CommonCode@1
	;***      266 : {
	;***      267 : 	switch (tblgPWM[ucgPWM_Cnt].Port){
	movw bc, ax
	mov a, LOWW(_tblgPWM)[bc]
	add a, #0xFC
	bz $.BB@LABEL@7_4
.BB@LABEL@7_1:	; entry
	dec a
	bz $.BB@LABEL@7_5
.BB@LABEL@7_2:	; entry
	cmp a, #0x02
	bnz $.BB@LABEL@7_6
.BB@LABEL@7_3:	; switch_clause_bb7
	;***      268 : 		case 4:
	;***      269 : 			PWM_Out_CH1();
	;***      270 : 			break;
	;***      271 : 		case 5:
	;***      272 : 			PWM_Out_CH2();
	;***      273 : 			break;
	;***      274 : 		case 7:
	;***      275 : 			PWM_Out_CH3();
	call !_PWM_Out_CH3
	br $.BB@LABEL@7_6
.BB@LABEL@7_4:	; switch_clause_bb
	call !_PWM_Out_CH1
	br $.BB@LABEL@7_6
.BB@LABEL@7_5:	; switch_clause_bb6
	call !_PWM_Out_CH2
.BB@LABEL@7_6:	; switch_break_bb
	;***      276 : 			break;
	;***      277 : 	}
	;***      278 : 
	;***      279 : 	tblgPWM[ucgPWM_Cnt].Input = LOW;
	mov a, _ucgPWM_Cnt
	mov b, a
	mov x, #0x04
	mulu x
	addw ax, #LOWW(_tblgPWM+0x00001)
	movw de, ax
	mov a, b
	;***      280 : 	ucgPWM_Cnt++;
	inc a
	mov _ucgPWM_Cnt, a
	mov [de+0x00], #0x00
	ret
_PWM_CH0_Init:
	.STACK _PWM_CH0_Init = 28
	;***      281 : }
	;***      282 : 
	;***      283 : /*******************************************************************************
	;***      284 : * Function Name: PWM_CH0_Init
	;***      285 : * Description  : initializing the PWM output that uses the Timer Array Unit(Cannel0).
	;***      286 : * Arguments    : Freq    ... setting frequency
	;***      287 : * Return Value : none
	;***      288 : ********************************************************************************/
	;***      289 : void PWM_CH0_Init( ULONG Freq )
	push bc
	push ax
	subw sp, #0x10
	movw ax, [sp+0x10]
	;***      290 : {
	;***      291 : 	USHORT	ushDivide[16] = {1, 2, 4, 8, 16, 32, 64, 128, 256, 512, 1024, 2048, 4096, 8192, 16384, 32768};
	;***      292 : 	UCHAR	ucsysclocksrc;
	;***      293 : 	UCHAR	ucsysclockfreq;
	;***      294 : 	
	;***      295 : 	/* Enables timer array unit input clock supply(TAU0EN=1) */
	;***      296 : 	PER0 |= 0x01;
	;***      297 : 
	;***      298 : 	TT0  |= 0x01;			/* TT00 = 1, TT01 = 1 */
	;***      299 : 	
	;***      300 : 	TMR00H = 0x00;
	;***      301 : 	TMR00L = 0x01;
	;***      302 : 	
	;***      303 : 	ucsysclocksrc  = SYS_CLOCK_SRC;
	;***      304 : 	ucsysclockfreq = SYS_CLOCK_FREQ;
	;***      305 : 	ulFprs = SYS_CLOCK_FREQ * 1000000;
	;***      306 : 	if( ucsysclocksrc == CLOCK_SRC_INTERNAL){
	;***      307 : 		if(ucsysclockfreq == 1){
	;***      308 : 			ulFprs = 1250000;
	;***      309 : 		}else if(ucsysclockfreq == 2){
	;***      310 : 			ulFprs = 2500000;
	;***      311 : 		}
	;***      312 : 	}
	;***      313 : 	ulDivideWork = ulFprs / (Freq * 256);
	shrw ax, 0x08
	movw de, ax
	movw ax, bc
	shlw ax, 0x08
	addw ax, de
	movw [sp+0x06], ax
	push ax
	movw ax, [sp+0x12]
	shlw ax, 0x08
	movw [sp+0x04], ax
	push ax
	call !__CommonCode@11
	call !!__COM_uldiv
	movw [sp+0x08], ax
	movw ax, bc
	movw [sp+0x04], ax
	addw sp, #0x04
	movw ax, [sp+0x06]
	;***      314 : 	ulRoundWork = ulFprs % (Freq * 256);
	push ax
	movw ax, [sp+0x04]
	push ax
	call !__CommonCode@11
	call !!__COM_ulrem
	movw de, #0x00F0
	movw hl, ax
	addw sp, #0x04
	mov a, [de]
	set1 a.0
	mov [de], a
	mov a, [de+0xC4]
	set1 a.0
	mov [de+0xC4], a
	mov [de+0xA1], #0x00
	mov [de+0xA0], #0x01
	movw _ulFprs+0x00002, #0x004C
	movw _ulFprs, #0x4B40
	movw ax, [sp+0x00]
	movw _ulDivideWork+0x00002, ax
	movw ax, [sp+0x04]
	movw _ulDivideWork, ax
	movw ax, hl
	movw _ulRoundWork, ax
	movw ax, bc
	movw _ulRoundWork+0x00002, ax
	movw ax, hl
	;***      315 : 	if(ulRoundWork > 0) {
	addw ax, bc
	sknz
.BB@LABEL@8_1:	; entry
	bnc $.BB@LABEL@8_5
.BB@LABEL@8_2:	; if_then_bb39
	movw ax, [sp+0x04]
	;***      316 : 		ulDivideWork += 1;
	addw ax, #0x0001
	movw [sp+0x04], ax
	movw _ulDivideWork, ax
	movw ax, [sp+0x00]
	sknc
.BB@LABEL@8_3:	; if_then_bb39
	incw ax
.BB@LABEL@8_4:	; if_then_bb39
	movw _ulDivideWork+0x00002, ax
.BB@LABEL@8_5:	; bb115.thread
	clrb _ucLoopCount
	clrb a
	mov [sp+0x02], a
.BB@LABEL@8_6:	; bb
	;***      317 : 	}
	;***      318 : 	for(ucLoopCount = 0; ucLoopCount < 16; ucLoopCount++) {
	;***      319 : 		if(ushDivide[ucLoopCount] >= (short)(ulDivideWork)) {
	mov x, #0x02
	mulu x
	movw bc, ax
	movw ax, SMRLW(.STR@1)[bc]
	movw [sp+0x00], ax
	movw ax, [sp+0x04]
	movw bc, ax
	movw ax, [sp+0x00]
	cmpw ax, bc
	bnc $.BB@LABEL@8_8
.BB@LABEL@8_7:	; if_break_bb112
	mov a, [sp+0x02]
	inc a
	mov [sp+0x02], a
	mov _ucLoopCount, a
	cmp a, #0x10
	bc $.BB@LABEL@8_6
	br !.BB@LABEL@8_18
.BB@LABEL@8_8:	; if_then_bb53
	movw ax, [sp+0x12]
	;***      320 : 			ulDivideWork = ushDivide[ucLoopCount];
	;***      321 : 			TPS0 = ucLoopCount & 0x0F;
	;***      322 : 			ulTDR00 = ulFprs / (ulDivideWork * Freq) - 1;
	push ax
	movw ax, [sp+0x12]
	push ax
	movw ax, [sp+0x04]
	clrw bc
	call !!__COM_lmul
	movw [sp+0x0E], ax
	movw ax, bc
	movw [sp+0x12], ax
	addw sp, #0x04
	push bc
	movw ax, [sp+0x0C]
	push ax
	call !__CommonCode@11
	call !!__COM_uldiv
	movw [sp+0x0C], ax
	movw ax, bc
	movw [sp+0x10], ax
	addw sp, #0x04
	movw ax, [sp+0x0E]
	;***      323 : 			ulRoundWork = ulFprs % (ulDivideWork * Freq);
	push ax
	movw ax, [sp+0x0C]
	push ax
	call !__CommonCode@11
	call !!__COM_ulrem
	movw [sp+0x08], ax
	movw ax, bc
	movw [sp+0x0A], ax
	movw _ulDivideWork+0x00002, #0x0000
	movw ax, [sp+0x04]
	movw _ulDivideWork, ax
	mov a, [sp+0x06]
	and a, #0x0F
	mov !0x01B6, a
	movw ax, [sp+0x0C]
	addw ax, #0xFFFF
	movw [sp+0x06], ax
	movw _ulTDR00, ax
	movw ax, [sp+0x10]
	skc
.BB@LABEL@8_9:	; if_then_bb53
	decw ax
.BB@LABEL@8_10:	; if_then_bb53
	movw _ulTDR00+0x00002, ax
	movw ax, [sp+0x0A]
	movw _ulRoundWork+0x00002, ax
	movw ax, [sp+0x08]
	movw _ulRoundWork, ax
	addw sp, #0x04
	movw ax, [sp+0x00]
	;***      324 : 			if(ulDivideWork == 1) {
	cmpw ax, #0x0001
	bnz $.BB@LABEL@8_13
.BB@LABEL@8_11:	; if_then_bb79
	movw ax, [sp+0x04]
	movw bc, ax
	;***      325 : 				if((ulRoundWork * 2) >= (ulDivideWork * Freq)) {
	shrw ax, 0x0F
	movw [sp+0x10], ax
	shlw bc, 0x01
	pop ax
	push bc
	movw ax, [sp+0x10]
	movw bc, ax
	movw ax, [sp+0x06]
	addw ax, ax
	addw ax, bc
	movw bc, ax
	movw ax, [sp+0x0E]
	xchw ax, bc
	cmpw ax, bc
	movw ax, [sp+0x0A]
	movw bc, ax
	movw ax, [sp+0x00]
	bnz $.BB@LABEL@8_15
.BB@LABEL@8_12:	; if_then_bb79
	cmpw ax, bc
	br $.BB@LABEL@8_15
.BB@LABEL@8_13:	; if_else_bb92
	movw ax, [sp+0x12]
	;***      326 : 					ulTDR00 += 1;
	;***      327 : 				}
	;***      328 : 			}
	;***      329 : 			else {
	;***      330 : 				if(ulRoundWork >= ((ulDivideWork / 2) * Freq)) {
	push ax
	movw ax, [sp+0x12]
	push ax
	movw ax, [sp+0x04]
	shrw ax, 0x01
	clrw bc
	call !!__COM_lmul
	addw sp, #0x04
	movw de, ax
	movw ax, [sp+0x06]
	cmpw ax, bc
	movw ax, [sp+0x04]
	sknz
.BB@LABEL@8_14:	; if_else_bb92
	cmpw ax, de
.BB@LABEL@8_15:	; if_else_bb92
	bc $.BB@LABEL@8_17
.BB@LABEL@8_16:	; if_break_bb105.PartialDrain
	movw ax, [sp+0x08]
	movw _ulTDR00, ax
	movw ax, [sp+0x0C]
	movw _ulTDR00+0x00002, ax
	movw ax, [sp+0x08]
	movw [sp+0x02], ax
.BB@LABEL@8_17:	; if_break_bb105
	movw ax, [sp+0x02]
	movw bc, ax
	;***      331 : 					ulTDR00 += 1;
	;***      332 : 				}
	;***      333 : 			}
	;***      334 : 			TDR00H = (UCHAR)(ulTDR00 >> 8);
	shrw ax, 0x08
	mov a, x
	mov 0xFFF19, a
	;***      335 : 			TDR00L = (UCHAR)ulTDR00;
	mov a, c
	mov 0xFFF18, a
.BB@LABEL@8_18:	; bb122
	movw de, #0x01B8
	;***      336 : 			break;
	;***      337 : 		}
	;***      338 : 	}
	;***      339 : 	TO0  &= (UCHAR)~0x01;	/* TO00  = 0 */
	mov a, [de]
	clr1 a.0
	mov [de], a
	;***      340 : 	TOE0 &= (UCHAR)~0x01;	/* TOE00 = 0 */
	mov a, [de+0x02]
	clr1 a.0
	mov [de+0x02], a
	addw sp, #0x14
	ret
_PWM_CH2_Init:
	.STACK _PWM_CH2_Init = 4
	;***      341 : }
	;***      342 : 
	;***      343 : /*******************************************************************************
	;***      344 : * Function Name: PWM_CH2_Init
	;***      345 : * Description  : initializing the PWM output that uses the Timer Array Unit(Cannel2).
	;***      346 : * Arguments    : Freq    ... setting frequency
	;***      347 : * Return Value : none
	;***      348 : ********************************************************************************/
	;***      349 : void PWM_CH2_Init( ULONG Freq )
	call !__CommonCode@10
	;***      350 : {
	;***      351 : #if defined DEVICE_R5F10Y4xASP
	;***      352 : 
	;***      353 : #if ( !defined(_IARCOMPILER) && !defined(__GCC__) ) || defined(_IARCOMPILER) || ( defined(__GCC__) && defined(PWM_CH2_USED) )
	;***      354 : 	/* Enables timer array unit input clock supply(TAU0EN=1) */
	;***      355 : 	PER0 |= 0x01;
	;***      356 : 
	;***      357 : 	TT0  |= 0x05;			/* TT02  = 1 */
	mov a, [hl+0xC4]
	or a, #0x05
	call !__CommonCode@9
	movw de, #0x0194
	call !__CommonCode@8
	;***      358 : 	
	;***      359 : 	PWM_CH0_Init(Freq);
	;***      360 : 
	;***      361 : 	TMR02H = 0x04;
	;***      362 : 	TMR02L = 0x09;
	;***      363 : 	TOM0 |= 0x04;			/* TOM02 = 1 */
	mov a, [de+0x2A]
	set1 a.2
	mov [de+0x2A], a
	;***      364 : 	TOL0 &= (UCHAR)~0x04;	/* TOL02 = 0 */
	mov a, [de+0x28]
	clr1 a.2
	mov [de+0x28], a
	;***      365 : 	TO0  &= (UCHAR)~0x04;	/* TO02  = 0 */
	mov a, [de+0x24]
	clr1 a.2
	mov [de+0x24], a
	;***      366 : 	TOE0 &= (UCHAR)~0x04;	/* TOE02 = 0 */
	mov a, [de+0x26]
	clr1 a.2
	mov [de+0x26], a
	call !__CommonCode@7
	;***      367 : 
	;***      368 : 	IF0L &= (UCHAR)~0x80;	/* TMIF00 = 0 */
	;***      369 : 	MK0L &= (UCHAR)~0x80;	/* TMMK00 = 0 */
	;***      370 : 	TS0  |= 0x01;			/* TS00   = 1(timer start) */
	mov a, [de+0x1E]
	set1 a.0
	mov [de+0x1E], a
	ret
_PWM_CH3_Init:
	.STACK _PWM_CH3_Init = 4
	;***      371 : #endif /* end of ( !defined(_IARCOMPILER) && !defined(__GCC__) ) || defined(_IARCOMPILER) || ( defined(__GCC__) && defined(PWM_CH2_USED) ) */
	;***      372 : 
	;***      373 : #endif /* end of defined DEVICE_R5F10Y4xASP */
	;***      374 : }
	;***      375 : 
	;***      376 : /*******************************************************************************
	;***      377 : * Function Name: PWM_CH3_Init
	;***      378 : * Description  : initializing the PWM output that uses the Timer Array Unit(Cannel3).
	;***      379 : * Arguments    : Freq    ... setting frequency
	;***      380 : * Return Value : none
	;***      381 : ********************************************************************************/
	;***      382 : void PWM_CH3_Init( ULONG Freq )
	call !__CommonCode@10
	;***      383 : {
	;***      384 : #if defined DEVICE_R5F10Y4xASP
	;***      385 : 
	;***      386 : #if ( !defined(_IARCOMPILER) && !defined(__GCC__) ) || defined(_IARCOMPILER) || ( defined(__GCC__) && defined(PWM_CH3_USED) )
	;***      387 : 	/* Enables timer array unit input clock supply(TAU0EN=1) */
	;***      388 : 	PER0 |= 0x01;
	;***      389 : 
	;***      390 : 	TT0  |= 0x09;			/* TT03  = 1 */
	mov a, [hl+0xC4]
	or a, #0x09
	call !__CommonCode@9
	movw de, #0x0196
	call !__CommonCode@8
	;***      391 : 	
	;***      392 : 	PWM_CH0_Init(Freq);
	;***      393 : 
	;***      394 : 	TMR03H = 0x04;
	;***      395 : 	TMR03L = 0x09;
	;***      396 : 	TOM0 |= 0x08;			/* TOM03 = 1 */
	mov a, [de+0x28]
	set1 a.3
	mov [de+0x28], a
	;***      397 : 	TOL0 &= (UCHAR)~0x08;	/* TOL03 = 0 */
	mov a, [de+0x26]
	clr1 a.3
	mov [de+0x26], a
	;***      398 : 	TO0  &= (UCHAR)~0x08;	/* TO03  = 0 */
	mov a, [de+0x22]
	clr1 a.3
	mov [de+0x22], a
	;***      399 : 	TOE0 &= (UCHAR)~0x08;	/* TOE03 = 0 */
	mov a, [de+0x24]
	clr1 a.3
	mov [de+0x24], a
	call !__CommonCode@7
	;***      400 : 
	;***      401 : 	IF0L &= (UCHAR)~0x80;	/* TMIF00 = 0 */
	;***      402 : 	MK0L &= (UCHAR)~0x80;	/* TMMK00 = 0 */
	;***      403 : 	TS0  |= 0x01;			/* TS00   = 1(timer start) */
	mov a, [de+0x1C]
	set1 a.0
	mov [de+0x1C], a
	ret
_PWM_Out_CH2:
	.STACK _PWM_Out_CH2 = 6
	;***      404 : #endif /* end of ( !defined(_IARCOMPILER) && !defined(__GCC__) ) || defined(_IARCOMPILER) || ( defined(__GCC__) && defined(PWM_CH3_USED) ) */
	;***      405 : 
	;***      406 : #endif /* end of defined DEVICE_R5F10Y4xASP */
	;***      407 : }
	;***      408 : 
	;***      409 : /*******************************************************************************
	;***      410 : * Function Name: PWM_Out_CH2
	;***      411 : * Description  : PWM that uses the Timer Array Unit(Cannel2) output.
	;***      412 : * Arguments    : none
	;***      413 : * Return Value : none
	;***      414 : ********************************************************************************/
	;***      415 : void PWM_Out_CH2( void )
	push hl
	call !__CommonCode@5
	;***      416 : {
	;***      417 : #if defined DEVICE_R5F10Y4xASP
	;***      418 : 
	;***      419 : #if ( !defined(_IARCOMPILER) && !defined(__GCC__) ) || defined(_IARCOMPILER) || ( defined(__GCC__) && defined(PWM_CH2_USED) )
	;***      420 : 	UCHAR	ucreg;
	;***      421 : 	UCHAR	regTDR02L;
	;***      422 : 
	;***      423 : 	if (tblgPWM[ucgPWM_Cnt].Input == HIGH){
	bnz $.BB@LABEL@11_6
.BB@LABEL@11_1:	; if_then_bb
	movw ax, bc
	call !__CommonCode@0
	;***      424 : 		if (tblgPWM[ucgPWM_Cnt].SetDuty != tblgPWM[ucgPWM_Cnt].OutDuty){
	cmp a, [hl]
	bz $.BB@LABEL@11_9
.BB@LABEL@11_2:	; if_then_bb23
	;***      425 : 			switch (tblgPWM[ucgPWM_Cnt].SetDuty){
	cmp0 a
	bz $.BB@LABEL@11_8
.BB@LABEL@11_3:	; if_then_bb23
	cmp a, #0x64
	bz $.BB@LABEL@11_5
.BB@LABEL@11_4:	; switch_clause_bb48
	call !__CommonCode@4
	;***      426 : 				case 0:
	;***      427 : 					TT0  |= 0x04;			/* TT02  = 1(timer stop) */
	;***      428 : 					TOE0 &= (UCHAR)~0x04;	/* TOE02 = 0 */
	;***      429 : 					PORT_PWM_CH2 = LOW;
	;***      430 : 					break;
	;***      431 : 				case 100:
	;***      432 : 					TT0  |= 0x04;			/* TT02  = 1(timer stop) */
	;***      433 : 					TOE0 &= (UCHAR)~0x04;	/* TOE02 = 0 */
	;***      434 : 					PORT_PWM_CH2 = HIGH;
	;***      435 : 					break;
	;***      436 : 				default:
	;***      437 : 					ucreg  = TDR00L;
	;***      438 : 					regTDR02L = PWM_Calc_Duty(ucreg);
	;***      439 : 					TT0  |= 0x04;			/* TT02  = 1(timer stop) */
	set1 a.2
	mov [de+0x02], a
	;***      440 : 					TDR02H = 0x00;
	mov 0xFFF65, #0x00
	mov a, x
	;***      441 : 					TDR02L = regTDR02L;
	mov 0xFFF64, a
	;***      442 : 					PORT_PWM_CH2 = LOW;
	clr1 0xFFF00.5
	;***      443 : 					TOE0 |= 0x04;			/* TOE02 = 1 */
	mov a, [de+0x08]
	set1 a.2
	mov [de+0x08], a
	;***      444 : 					TS0  |= 0x04;			/* TS02  = 1(timer start) */
	mov a, [de]
	set1 a.2
	mov [de], a
	br $.BB@LABEL@11_9
.BB@LABEL@11_5:	; switch_clause_bb38
	call !__CommonCode@6
	set1 0xFFF00.5
	br $.BB@LABEL@11_9
.BB@LABEL@11_6:	; if_else_bb
	;***      445 : 					break;
	;***      446 : 			}
	;***      447 : 		}
	;***      448 : 
	;***      449 : 	}else if (tblgPWM[ucgPWM_Cnt].Input == LOW){
	cmp0 a
	bnz $.BB@LABEL@11_9
.BB@LABEL@11_7:	; if_then_bb74
	call !__CommonCode@3
.BB@LABEL@11_8:	; switch_clause_bb
	call !__CommonCode@6
	clr1 0xFFF00.5
.BB@LABEL@11_9:	; if_break_bb88
	call !__CommonCode@1
	call !__CommonCode@0
	;***      450 : 		tblgPWM[ucgPWM_Cnt].SetDuty = 0;
	;***      451 : 		TT0  |= 0x04;						/* TT02  = 1(timer stop) */
	;***      452 : 		TOE0 &= (UCHAR)~0x04;				/* TOE02 = 0 */
	;***      453 : 		PORT_PWM_CH2 = LOW;
	;***      454 : 	}
	;***      455 : 	tblgPWM[ucgPWM_Cnt].OutDuty = tblgPWM[ucgPWM_Cnt].SetDuty;
	mov [hl], a
	pop hl
	ret
_PWM_Out_CH3:
	.STACK _PWM_Out_CH3 = 6
	;***      456 : #endif /* end of ( !defined(_IARCOMPILER) && !defined(__GCC__) ) || defined(_IARCOMPILER) || ( defined(__GCC__) && defined(PWM_CH2_USED) ) */
	;***      457 : 
	;***      458 : #endif /* end of defined DEVICE_R5F10Y4xASP */
	;***      459 : }
	;***      460 : 
	;***      461 : /*******************************************************************************
	;***      462 : * Function Name: PWM_Out_CH3
	;***      463 : * Description  : PWM that uses the Timer Array Unit(Cannel2) output.
	;***      464 : * Arguments    : none
	;***      465 : * Return Value : none
	;***      466 : ********************************************************************************/
	;***      467 : void PWM_Out_CH3( void )
	push hl
	call !__CommonCode@5
	;***      468 : {
	;***      469 : #if defined DEVICE_R5F10Y4xASP
	;***      470 : 
	;***      471 : #if ( !defined(_IARCOMPILER) && !defined(__GCC__) ) || defined(_IARCOMPILER) || ( defined(__GCC__) && defined(PWM_CH3_USED) )
	;***      472 : 	UCHAR	ucreg;
	;***      473 : 	UCHAR	regTDR03L;
	;***      474 : 
	;***      475 : 	if (tblgPWM[ucgPWM_Cnt].Input == HIGH){
	bnz $.BB@LABEL@12_6
.BB@LABEL@12_1:	; if_then_bb
	movw ax, bc
	call !__CommonCode@0
	;***      476 : 		if (tblgPWM[ucgPWM_Cnt].SetDuty != tblgPWM[ucgPWM_Cnt].OutDuty){
	cmp a, [hl]
	bz $.BB@LABEL@12_9
.BB@LABEL@12_2:	; if_then_bb23
	;***      477 : 			switch (tblgPWM[ucgPWM_Cnt].SetDuty){
	cmp0 a
	bz $.BB@LABEL@12_8
.BB@LABEL@12_3:	; if_then_bb23
	cmp a, #0x64
	bz $.BB@LABEL@12_5
.BB@LABEL@12_4:	; switch_clause_bb48
	call !__CommonCode@4
	;***      478 : 				case 0:
	;***      479 : 					TT0  |= 0x08;			/* TT03  = 1(timer stop) */
	;***      480 : 					TOE0 &= (UCHAR)~0x08;	/* TOE03 = 0 */
	;***      481 : 					PORT_PWM_CH3 = LOW;
	;***      482 : 					break;
	;***      483 : 				case 100:
	;***      484 : 					TT0  |= 0x08;			/* TT03  = 1(timer stop) */
	;***      485 : 					TOE0 &= (UCHAR)~0x08;	/* TOE03 = 0 */
	;***      486 : 					PORT_PWM_CH3 = HIGH;
	;***      487 : 					break;
	;***      488 : 				default:
	;***      489 : 					ucreg  = TDR00L;
	;***      490 : 					regTDR03L = PWM_Calc_Duty(ucreg);
	;***      491 : 					TT0  |= 0x08;			/* TT03  = 1(timer stop) */
	set1 a.3
	mov [de+0x02], a
	;***      492 : 					TDR03H = 0x00;
	mov 0xFFF67, #0x00
	mov a, x
	;***      493 : 					TDR03L = regTDR03L;
	mov 0xFFF66, a
	;***      494 : 					PORT_PWM_CH3 = LOW;
	clr1 0xFFF00.7
	;***      495 : 					TOE0 |= 0x08;			/* TOE03 = 1 */
	mov a, [de+0x08]
	set1 a.3
	mov [de+0x08], a
	;***      496 : 					TS0  |= 0x08;			/* TS03  = 1(timer start) */
	mov a, [de]
	set1 a.3
	mov [de], a
	br $.BB@LABEL@12_9
.BB@LABEL@12_5:	; switch_clause_bb38
	call !__CommonCode@2
	set1 0xFFF00.7
	br $.BB@LABEL@12_9
.BB@LABEL@12_6:	; if_else_bb
	;***      497 : 					break;
	;***      498 : 			}
	;***      499 : 		}
	;***      500 : 
	;***      501 : 	}else if (tblgPWM[ucgPWM_Cnt].Input == LOW){
	cmp0 a
	bnz $.BB@LABEL@12_9
.BB@LABEL@12_7:	; if_then_bb74
	call !__CommonCode@3
.BB@LABEL@12_8:	; switch_clause_bb
	call !__CommonCode@2
	clr1 0xFFF00.7
.BB@LABEL@12_9:	; if_break_bb88
	call !__CommonCode@1
	call !__CommonCode@0
	;***      502 : 		tblgPWM[ucgPWM_Cnt].SetDuty = 0;
	;***      503 : 		TT0  |= 0x08;						/* TT03  = 1(timer stop) */
	;***      504 : 		TOE0 &= (UCHAR)~0x08;				/* TOE03 = 0 */
	;***      505 : 		PORT_PWM_CH3 = LOW;
	;***      506 : 	}
	;***      507 : 	tblgPWM[ucgPWM_Cnt].OutDuty = tblgPWM[ucgPWM_Cnt].SetDuty;
	mov [hl], a
	pop hl
	ret
__CommonCode@0:
	.STACK __CommonCode@0 = 4
	addw ax, #LOWW(_tblgPWM)
	movw bc, ax
	addw ax, #0x0003
	movw hl, ax
	incw bc
	incw bc
	movw ax, bc
	movw de, ax
	mov a, [de]
	ret
__CommonCode@1:
	.STACK __CommonCode@1 = 4
	mov a, _ucgPWM_Cnt
	mov x, #0x04
	mulu x
	ret
__CommonCode@2:
	.STACK __CommonCode@2 = 4
	movw de, #0x01B4
	mov a, [de]
	set1 a.3
	mov [de], a
	mov a, [de+0x06]
	clr1 a.3
	mov [de+0x06], a
	ret
__CommonCode@3:
	.STACK __CommonCode@3 = 4
	movw ax, [sp+0x04]
	movw bc, ax
	shlw bc, 0x02
	mov LOWW(_tblgPWM+0x00002)[bc], #0x00
	ret
__CommonCode@4:
	.STACK __CommonCode@4 = 4
	mov a, 0xFFF18
	call !_PWM_Calc_Duty
	movw de, #0x01B2
	mov x, a
	mov a, [de+0x02]
	ret
__CommonCode@5:
	.STACK __CommonCode@5 = 4
	mov a, _ucgPWM_Cnt
	shrw ax, 8+0x00000
	movw [sp+0x04], ax
	shlw ax, 0x02
	movw bc, ax
	mov a, LOWW(_tblgPWM+0x00001)[bc]
	cmp a, #0x01
	ret
__CommonCode@6:
	.STACK __CommonCode@6 = 4
	movw de, #0x01B4
	mov a, [de]
	set1 a.2
	mov [de], a
	mov a, [de+0x06]
	clr1 a.2
	mov [de+0x06], a
	ret
__CommonCode@7:
	.STACK __CommonCode@7 = 4
	mov a, #0x7F
	mov x, a
	and a, !0xFFE0
	mov 0xFFFE0, a
	mov a, x
	and a, !0xFFE4
	mov 0xFFFE4, a
	ret
__CommonCode@8:
	.STACK __CommonCode@8 = 4
	mov [de+0x01], #0x04
	mov [de+0x00], #0x09
	ret
__CommonCode@9:
	.STACK __CommonCode@9 = 4
	mov [hl+0xC4], a
	movw ax, de
	call !_PWM_CH0_Init
	ret
__CommonCode@10:
	.STACK __CommonCode@10 = 4
	movw hl, #0x00F0
	movw de, ax
	mov a, [hl]
	set1 a.0
	mov [hl], a
	ret
__CommonCode@11:
	.STACK __CommonCode@11 = 4
	movw bc, #0x004C
	movw ax, #0x4B40
	ret
__CommonCode@12:
	.STACK __CommonCode@12 = 4
	movw de, #0x01B4
	mov a, [de]
	set1 a.1
	mov [de], a
	mov a, [de+0x06]
	clr1 a.1
	mov [de+0x06], a
	ret
	;***      508 : #endif /* end of ( !defined(_IARCOMPILER) && !defined(__GCC__) ) || defined(_IARCOMPILER) || ( defined(__GCC__) && defined(PWM_CH3_USED) ) */
	;***      509 : 
	;***      510 : #endif /* end of defined DEVICE_R5F10Y4xASP */
	;***      511 : }
	;***      512 : 
	;***      513 : #endif /* end of defined PWM_USED */
	.SECTION .sbss,SBSS
_tblgPWM:
	.DS (8)
_ucLoopCount:
	.DS (1)
	.ALIGN 2
_ulFprs:
	.DS (4)
	.ALIGN 2
_ulDivideWork:
	.DS (4)
	.ALIGN 2
_ulRoundWork:
	.DS (4)
	.ALIGN 2
_ulTDR00:
	.DS (4)
	.SECTION .sdata,SDATA
_ucgPWM_Cnt:
	.DS (1)
	.SECTION .const,CONST
	.ALIGN 2
.STR@1:
	.DB2 0x0001,0x0002,0x0004,0x0008,0x0010,0x0020,0x0040,0x0080,0x0100,0x0200,0x0400,0x0800
	.DB2 0x1000,0x2000,0x4000,0x8000
