#CC-RL Compiler RL78 Assembler Source
#@  CC-RL Version : V1.08.00 [28 Nov 2018]
#@  Commmand :
#@   -cpu=S1
#@   -obj_path=.\obj\
#@   -asm_path=.\obj\
#@   -dev=C:\Program Files (x86)\Renesas Electronics\Applilet EZ PL for RL78 V2.20\Tools\BIN\..\..\Tools\DEV\DR5F10Y47.DVF
#@   -c
#@   -I C:\Program Files (x86)\Renesas Electronics\CS+\CC\CC-RL\V1.08.00\inc,.\include
#@   -Osize
#@   -pass_source
#@   src\userpanel.c
#@  compiled at Tue Jun 18 19:05:23 2019

	.PUBLIC _PANEL_CPL_PWM

	.SECTION .text,TEXT
_PANEL_CPL_PWM:
	.STACK _PANEL_CPL_PWM = 6
	;***        1 : /*******************************************************************************
	;***        2 : * DISCLAIMER
	;***        3 : * This software is supplied by Renesas Electronics Corporation and is only
	;***        4 : * intended for use with Renesas products. No other uses are authorized. This
	;***        5 : * software is owned by Renesas Electronics Corporation and is protected under
	;***        6 : * all applicable laws, including copyright laws.
	;***        7 : * THIS SOFTWARE IS PROVIDED "AS IS" AND RENESAS MAKES NO WARRANTIES REGARDING
	;***        8 : * THIS SOFTWARE, WHETHER EXPRESS, IMPLIED OR STATUTORY, INCLUDING BUT NOT
	;***        9 : * LIMITED TO WARRANTIES OF MERCHANTABILITY, FITNESS FOR A PARTICULAR PURPOSE
	;***       10 : * AND NON-INFRINGEMENT. ALL SUCH WARRANTIES ARE EXPRESSLY DISCLAIMED.
	;***       11 : * TO THE MAXIMUM EXTENT PERMITTED NOT PROHIBITED BY LAW, NEITHER RENESAS
	;***       12 : * ELECTRONICS CORPORATION NOR ANY OF ITS AFFILIATED COMPANIES SHALL BE LIABLE
	;***       13 : * FOR ANY DIRECT, INDIRECT, SPECIAL, INCIDENTAL OR CONSEQUENTIAL DAMAGES FOR
	;***       14 : * ANY REASON RELATED TO THIS SOFTWARE, EVEN IF RENESAS OR ITS AFFILIATES HAVE
	;***       15 : * BEEN ADVISED OF THE POSSIBILITY OF SUCH DAMAGES.
	;***       16 : * Renesas reserves the right, without notice, to make changes to this software
	;***       17 : * and to discontinue the availability of this software. By using this software,
	;***       18 : * you agree to the additional terms and conditions found by accessing the
	;***       19 : * following link:
	;***       20 : * http://www.renesas.com/disclaimer
	;***       21 : *
	;***       22 : * Copyright (C) 2016 Renesas Electronics Corporation. All rights reserved.
	;***       23 : *******************************************************************************/
	;***       24 : 
	;***       25 : /*******************************************************************************
	;***       26 : * File Name    : userpanel.c
	;***       27 : * Version      : Applilet EZ PL for RL78
	;***       28 : * Device(s)    : R5F10Y14,R5F10Y16,R5F10Y17,R5F10Y44,R5F10Y46,R5F10Y47
	;***       29 : * Tool-Chain   : CC-RL
	;***       30 : * Description  : This file implements the function of user panel.
	;***       31 : * Creation Date: 2016/09/14
	;***       32 : *******************************************************************************/
	;***       33 : 
	;***       34 : /*******************************************************************************
	;***       35 : Includes <System Includes> , "Project Includes"
	;***       36 : *******************************************************************************/
	;***       37 : #include "sfr.h"
	;***       38 : #include "common.h"
	;***       39 : #include "config.h"
	;***       40 : #include "userpanel.h"
	;***       41 : 
	;***       42 : /*******************************************************************************
	;***       43 : Macro definitions
	;***       44 : *******************************************************************************/
	;***       45 : 
	;***       46 : /*******************************************************************************
	;***       47 : Typedef definitions
	;***       48 : *******************************************************************************/
	;***       49 : 
	;***       50 : /*******************************************************************************
	;***       51 : Imported global variables and functions (from other files)
	;***       52 : *******************************************************************************/
	;***       53 : 
	;***       54 : /*******************************************************************************
	;***       55 : Exported global variables and functions (to be accessed by other files)
	;***       56 : *******************************************************************************/
	;***       57 : 
	;***       58 : /*******************************************************************************
	;***       59 : Private variables and functions
	;***       60 : *******************************************************************************/
	;***       61 : 
	;***       62 : /*******************************************************************************
	;***       63 : User Program Functions
	;***       64 : *******************************************************************************/
	;***       65 : 
	;***       66 : /*--- Variable declaration ---*/
	;***       67 :     /* ɕϐLqĂ */
	;***       68 :     /* 
	;***       69 :     UCHAR work;
	;***       70 :     */
	;***       71 : 
	;***       72 : /*--------------------------------*/
	;***       73 : 
	;***       74 : /* Function Declaration */
	;***       75 : void PANEL_CPL_PWM(UCHAR In_1, UCHAR *Out_1)
	push bc
	pop de
	;***       76 : {
	;***       77 :     /* ɏLqĂ */
	;***       78 : 	if ( In_1 == 1 )
	dec a
	bnz $.BB@LABEL@1_3
.BB@LABEL@1_1:	; if_then_bb
	;***       79 : 	{
	;***       80 : 		if ( ( TOL0 & 0x04 ) == 0 )
	mov a, !0x01BC
	bt a.2, $.BB@LABEL@1_5
.BB@LABEL@1_2:	; if_then_bb10
	movw hl, #0x01BC
	;***       81 : 		{
	;***       82 : 			TOL0 |= 0x04;
	mov a, [hl]
	set1 a.2
	mov [hl], a
	;***       83 : 			*Out_1 = 1;
	mov [de+0x00], #0x01
	ret
.BB@LABEL@1_3:	; if_else_bb
	;***       84 : 		}
	;***       85 : 	}
	;***       86 : 	else
	;***       87 : 	{
	;***       88 : 		if ( TOL0 & 0x04 ) 
	mov a, !0x01BC
	bf a.2, $.BB@LABEL@1_5
.BB@LABEL@1_4:	; if_then_bb22
	movw hl, #0x01BC
	;***       89 : 		{
	;***       90 : 			TOL0 &= 0xFB;
	mov a, [hl]
	clr1 a.2
	mov [hl], a
	;***       91 : 			*Out_1 = 0;
	mov [de+0x00], #0x00
.BB@LABEL@1_5:	; return
	ret
	;***       92 : 		}
	;***       93 : 	}
	;***       94 : 
	;***       95 : }
	;***       96 : 
