#CC-RL Compiler RL78 Assembler Source
#@  CC-RL Version : V1.08.00 [28 Nov 2018]
#@  Commmand :
#@   -cpu=S1
#@   -obj_path=.\obj\
#@   -asm_path=.\obj\
#@   -dev=C:\Program Files (x86)\Renesas Electronics\Applilet EZ PL for RL78 V2.20\Tools\BIN\..\..\Tools\DEV\DR5F10Y47.DVF
#@   -c
#@   -I C:\Program Files (x86)\Renesas Electronics\CS+\CC\CC-RL\V1.08.00\inc,.\include
#@   -Osize
#@   -pass_source
#@   src\system.c
#@  compiled at Tue Jun 18 17:43:40 2019

	.PUBLIC _Clock_Init

	.SECTION .text,TEXT
_Clock_Init:
	.STACK _Clock_Init = 4
	;***        1 : /*******************************************************************************
	;***        2 : * DISCLAIMER
	;***        3 : * This software is supplied by Renesas Electronics Corporation and is only
	;***        4 : * intended for use with Renesas products. No other uses are authorized. This
	;***        5 : * software is owned by Renesas Electronics Corporation and is protected under
	;***        6 : * all applicable laws, including copyright laws.
	;***        7 : * THIS SOFTWARE IS PROVIDED "AS IS" AND RENESAS MAKES NO WARRANTIES REGARDING
	;***        8 : * THIS SOFTWARE, WHETHER EXPRESS, IMPLIED OR STATUTORY, INCLUDING BUT NOT
	;***        9 : * LIMITED TO WARRANTIES OF MERCHANTABILITY, FITNESS FOR A PARTICULAR PURPOSE
	;***       10 : * AND NON-INFRINGEMENT. ALL SUCH WARRANTIES ARE EXPRESSLY DISCLAIMED.
	;***       11 : * TO THE MAXIMUM EXTENT PERMITTED NOT PROHIBITED BY LAW, NEITHER RENESAS
	;***       12 : * ELECTRONICS CORPORATION NOR ANY OF ITS AFFILIATED COMPANIES SHALL BE LIABLE
	;***       13 : * FOR ANY DIRECT, INDIRECT, SPECIAL, INCIDENTAL OR CONSEQUENTIAL DAMAGES FOR
	;***       14 : * ANY REASON RELATED TO THIS SOFTWARE, EVEN IF RENESAS OR ITS AFFILIATES HAVE
	;***       15 : * BEEN ADVISED OF THE POSSIBILITY OF SUCH DAMAGES.
	;***       16 : * Renesas reserves the right, without notice, to make changes to this software
	;***       17 : * and to discontinue the availability of this software. By using this software,
	;***       18 : * you agree to the additional terms and conditions found by accessing the
	;***       19 : * following link:
	;***       20 : * http://www.renesas.com/disclaimer
	;***       21 : *
	;***       22 : * Copyright (C) 2016 Renesas Electronics Corporation. All rights reserved.
	;***       23 : *******************************************************************************/
	;***       24 : 
	;***       25 : /*******************************************************************************
	;***       26 : * File Name    : system.c
	;***       27 : * Version      : Applilet EZ PL for RL78
	;***       28 : * Device(s)    : R5F10Y14,R5F10Y16,R5F10Y17,R5F10Y44,R5F10Y46,R5F10Y47
	;***       29 : * Tool-Chain   : CC-RL
	;***       30 : * Description  : This file implements main function.
	;***       31 : * Creation Date: 2016/09/14
	;***       32 : *******************************************************************************/
	;***       33 : 
	;***       34 : /*******************************************************************************
	;***       35 : Includes <System Includes> , "Project Includes"
	;***       36 : *******************************************************************************/
	;***       37 : #include "sfr.h"
	;***       38 : #include "common.h"
	;***       39 : #include "config.h"
	;***       40 : #include "system.h"
	;***       41 : 
	;***       42 : /*******************************************************************************
	;***       43 : Macro definitions
	;***       44 : *******************************************************************************/
	;***       45 : 
	;***       46 : /*******************************************************************************
	;***       47 : Typedef definitions
	;***       48 : *******************************************************************************/
	;***       49 : 
	;***       50 : /*******************************************************************************
	;***       51 : Imported global variables and functions (from other files)
	;***       52 : *******************************************************************************/
	;***       53 : 
	;***       54 : /*******************************************************************************
	;***       55 : Exported global variables and functions (to be accessed by other files)
	;***       56 : *******************************************************************************/
	;***       57 : 
	;***       58 : /*******************************************************************************
	;***       59 : Private variables and functions
	;***       60 : *******************************************************************************/
	;***       61 : 
	;***       62 : /*******************************************************************************
	;***       63 : * Function Name: Clock_Init
	;***       64 : * Description  : This function initializes the clock generator.
	;***       65 : * Arguments    : none
	;***       66 : * Return Value : none
	;***       67 : ********************************************************************************/
	;***       68 : void Clock_Init( void )
	;***       69 : {
	;***       70 : #if defined DEVICE_R5F10Y4xASP
	;***       71 : 	UCHAR	ucsysclocksrc;
	;***       72 : 	UCHAR	ucsysclockfreq;
	;***       73 : 	UCHAR	uccmcinitval;
	;***       74 : 
	;***       75 : 	ucsysclocksrc = SYS_CLOCK_SRC;
	;***       76 : 	if( (ucsysclocksrc == CLOCK_SRC_X1) || (ucsysclocksrc == CLOCK_SRC_EXTERNAL) ) {
	ret
	;***       77 : 		uccmcinitval = 0x00;
	;***       78 : 		if(ucsysclocksrc == CLOCK_SRC_X1) {
	;***       79 : 			uccmcinitval = CMC_MODE_X1;
	;***       80 : 			ucsysclockfreq = SYS_CLOCK_FREQ;
	;***       81 : 			if(ucsysclockfreq > 10) {
	;***       82 : 				uccmcinitval |= CMC_SYS_CLOCK_OVER_10MHZ;
	;***       83 : 			}
	;***       84 : 			else {
	;***       85 : 				uccmcinitval |= CMC_SYS_CLOCK_UNDER_10MHZ;
	;***       86 : 			}
	;***       87 : 		}
	;***       88 : 		else {
	;***       89 : 			uccmcinitval = CMC_MODE_EXTCLOCK;
	;***       90 : 		}
	;***       91 : 		CMC = uccmcinitval;
	;***       92 : 
	;***       93 : 		/* MSTOP=0 */
	;***       94 : 		CSC = CSC_INIT_VAL;
	;***       95 : 
	;***       96 : 		if(ucsysclocksrc == CLOCK_SRC_X1) {
	;***       97 : 			while(OSTC != 0xFF);
	;***       98 : 		}
	;***       99 : 
	;***      100 : 		/* MCM0=1 */
	;***      101 : 		CKC = CKC_INIT_VAL;
	;***      102 : 	}
	;***      103 : #endif
	;***      104 : }
