#CC-RL Compiler RL78 Assembler Source
#@  CC-RL Version : V1.08.00 [28 Nov 2018]
#@  Commmand :
#@   -cpu=S1
#@   -obj_path=.\obj\
#@   -asm_path=.\obj\
#@   -dev=C:\Program Files (x86)\Renesas Electronics\Applilet EZ PL for RL78 V2.20\Tools\BIN\..\..\Tools\DEV\DR5F10Y47.DVF
#@   -c
#@   -I C:\Program Files (x86)\Renesas Electronics\CS+\CC\CC-RL\V1.08.00\inc,.\include
#@   -Osize
#@   -pass_source
#@   src\int.c
#@  compiled at Tue Jun 18 17:45:56 2019

	.PUBLIC _MD_INTP0
	.PUBLIC _MD_INTP1
	.PUBLIC _MD_INTP2
	.PUBLIC _MD_INTP3
	.PUBLIC _MD_INTIT
	.PUBLIC _INT_Init

	.SECTION .text,TEXT
_MD_INTP0	.vector 0x0006
_MD_INTP0:
	.STACK _MD_INTP0 = 4
	;***        1 : /*******************************************************************************
	;***        2 : * DISCLAIMER
	;***        3 : * This software is supplied by Renesas Electronics Corporation and is only
	;***        4 : * intended for use with Renesas products. No other uses are authorized. This
	;***        5 : * software is owned by Renesas Electronics Corporation and is protected under
	;***        6 : * all applicable laws, including copyright laws.
	;***        7 : * THIS SOFTWARE IS PROVIDED "AS IS" AND RENESAS MAKES NO WARRANTIES REGARDING
	;***        8 : * THIS SOFTWARE, WHETHER EXPRESS, IMPLIED OR STATUTORY, INCLUDING BUT NOT
	;***        9 : * LIMITED TO WARRANTIES OF MERCHANTABILITY, FITNESS FOR A PARTICULAR PURPOSE
	;***       10 : * AND NON-INFRINGEMENT. ALL SUCH WARRANTIES ARE EXPRESSLY DISCLAIMED.
	;***       11 : * TO THE MAXIMUM EXTENT PERMITTED NOT PROHIBITED BY LAW, NEITHER RENESAS
	;***       12 : * ELECTRONICS CORPORATION NOR ANY OF ITS AFFILIATED COMPANIES SHALL BE LIABLE
	;***       13 : * FOR ANY DIRECT, INDIRECT, SPECIAL, INCIDENTAL OR CONSEQUENTIAL DAMAGES FOR
	;***       14 : * ANY REASON RELATED TO THIS SOFTWARE, EVEN IF RENESAS OR ITS AFFILIATES HAVE
	;***       15 : * BEEN ADVISED OF THE POSSIBILITY OF SUCH DAMAGES.
	;***       16 : * Renesas reserves the right, without notice, to make changes to this software
	;***       17 : * and to discontinue the availability of this software. By using this software,
	;***       18 : * you agree to the additional terms and conditions found by accessing the
	;***       19 : * following link:
	;***       20 : * http://www.renesas.com/disclaimer
	;***       21 : *
	;***       22 : * Copyright (C) 2016 Renesas Electronics Corporation. All rights reserved.
	;***       23 : *******************************************************************************/
	;***       24 : 
	;***       25 : /*******************************************************************************
	;***       26 : * File Name    : int.c
	;***       27 : * Version      : Applilet EZ PL for RL78
	;***       28 : * Device(s)    : R5F10Y14,R5F10Y16,R5F10Y17,R5F10Y44,R5F10Y46,R5F10Y47
	;***       29 : * Tool-Chain   : CC-RL
	;***       30 : * Description  : This file implements main function.
	;***       31 : * Creation Date: 2016/09/14
	;***       32 : *******************************************************************************/
	;***       33 : 
	;***       34 : /*******************************************************************************
	;***       35 : Includes <System Includes> , "Project Includes"
	;***       36 : *******************************************************************************/
	;***       37 : #ifdef __CCRL__
	;***       38 : #include "sfr.h"
	;***       39 : #include "common.h"
	;***       40 : #include "config.h"
	;***       41 : #include "int.h"
	;***       42 : #pragma interrupt	MD_INTP0(vect=INTP0)
	;***       43 : #pragma interrupt	MD_INTP1(vect=INTP1)
	;***       44 : #ifdef DEVICE_R5F10Y4xASP
	;***       45 : #pragma interrupt	MD_INTP2(vect=INTP2)
	;***       46 : #pragma interrupt	MD_INTP3(vect=INTP3)
	;***       47 : #pragma interrupt	MD_INTIT(vect=INTIT)
	;***       48 : #endif /*DEVICE_R5F10Y4xASP*/
	;***       49 : #else
	;***       50 : #error "undefined compiler"
	;***       51 : #endif
	;***       52 : 
	;***       53 : /*******************************************************************************
	;***       54 : Macro definitions
	;***       55 : *******************************************************************************/
	;***       56 : 
	;***       57 : /*******************************************************************************
	;***       58 : Typedef definitions
	;***       59 : *******************************************************************************/
	;***       60 : 
	;***       61 : /*******************************************************************************
	;***       62 : Imported global variables and functions (from other files)
	;***       63 : *******************************************************************************/
	;***       64 : 
	;***       65 : /*******************************************************************************
	;***       66 : Exported global variables and functions (to be accessed by other files)
	;***       67 : *******************************************************************************/
	;***       68 : 
	;***       69 : /*******************************************************************************
	;***       70 : Private variables and functions
	;***       71 : *******************************************************************************/
	;***       72 : 
	;***       73 : 
	;***       74 : /*******************************************************************************
	;***       75 : * Function Name: __interrupt MD_INTP0
	;***       76 : * Description  : Interrupt processing of external interrupt of signal detection
	;***       77 : * Arguments    : none
	;***       78 : * Return Value : none
	;***       79 : ********************************************************************************/
	;***       80 : #ifdef __CCRL__
	;***       81 : void MD_INTP0( void )
	reti
_MD_INTP1	.vector 0x0008
_MD_INTP1:
	.STACK _MD_INTP1 = 4
	;***       82 : #else
	;***       83 : #error "undefined compiler"
	;***       84 : #endif
	;***       85 : {
	;***       86 : }
	;***       87 : 
	;***       88 : /*******************************************************************************
	;***       89 : * Function Name: __interrupt MD_INTP1
	;***       90 : * Description  : Interrupt processing of external interrupt of signal detection
	;***       91 : * Arguments    : none
	;***       92 : * Return Value : none
	;***       93 : ********************************************************************************/
	;***       94 : #ifdef __CCRL__
	;***       95 : void MD_INTP1( void )
	reti
_MD_INTP2	.vector 0x001A
_MD_INTP2:
	.STACK _MD_INTP2 = 4
	;***       96 : #else
	;***       97 : #error "undefined compiler"
	;***       98 : #endif
	;***       99 : {
	;***      100 : }
	;***      101 : 
	;***      102 : #ifdef DEVICE_R5F10Y4xASP
	;***      103 : /*******************************************************************************
	;***      104 : * Function Name: __interrupt MD_INTP2
	;***      105 : * Description  : Interrupt processing of external interrupt of signal detection
	;***      106 : * Arguments    : none
	;***      107 : * Return Value : none
	;***      108 : ********************************************************************************/
	;***      109 : #ifdef __CCRL__
	;***      110 : void MD_INTP2( void )
	reti
_MD_INTP3	.vector 0x001C
_MD_INTP3:
	.STACK _MD_INTP3 = 4
	;***      111 : #else
	;***      112 : #error "undefined compiler"
	;***      113 : #endif
	;***      114 : {
	;***      115 : }
	;***      116 : 
	;***      117 : /*******************************************************************************
	;***      118 : * Function Name: __interrupt MD_INTP3
	;***      119 : * Description  : Interrupt processing of external interrupt of signal detection
	;***      120 : * Arguments    : none
	;***      121 : * Return Value : none
	;***      122 : ********************************************************************************/
	;***      123 : #ifdef __CCRL__
	;***      124 : void MD_INTP3( void )
	reti
_MD_INTIT	.vector 0x0026
_MD_INTIT:
	.STACK _MD_INTIT = 4
	;***      125 : #else
	;***      126 : #error "undefined compiler"
	;***      127 : #endif
	;***      128 : {
	;***      129 : }
	;***      130 : 
	;***      131 : /*******************************************************************************
	;***      132 : * Function Name: __interrupt MD_INTIT
	;***      133 : * Description  : Interrupt processing of interval timer of signal detection
	;***      134 : * Arguments    : none
	;***      135 : * Return Value : none
	;***      136 : ********************************************************************************/
	;***      137 : #ifdef __CCRL__
	;***      138 : void MD_INTIT( void )
	reti
_INT_Init:
	.STACK _INT_Init = 4
	;***      139 : #else
	;***      140 : #error "undefined compiler"
	;***      141 : #endif
	;***      142 : {
	;***      143 : }
	;***      144 : 
	;***      145 : #endif /*DEVICE_R5F10Y4xASP*/
	;***      146 : 
	;***      147 : 
	;***      148 : /*******************************************************************************
	;***      149 : * Function Name: INT_Init
	;***      150 : * Description  : This function initializes the external INT,
	;***      151 : *                including enable or disable,priority setting
	;***      152 : * Arguments    : none
	;***      153 : * Return Value : none
	;***      154 : ********************************************************************************/
	;***      155 : void INT_Init( void )
	;***      156 : {
	;***      157 : 	MK0L = 0xFF;			/* All individual interrupt is prohibited	*/
	mov 0xFFFE4, #0xFF
	;***      158 : 	IF0L = 0x00;			/* Interrupt request flag all clearness		*/
	mov 0xFFFE0, #0x00
	;***      159 : 	PR00L = 0xFF;			/* Priority level clearness					*/
	mov 0xFFFE8, #0xFF
	;***      160 : 	PR10L = 0xFF;			/* Priority level clearness					*/
	mov 0xFFFEC, #0xFF
	;***      161 : 
	;***      162 : 	MK0H = 0xFF;			/* All individual interrupt is prohibited	*/
	mov 0xFFFE5, #0xFF
	;***      163 : 	IF0H = 0x00;			/* Interrupt request flag all clearness		*/
	mov 0xFFFE1, #0x00
	;***      164 : 	PR00H = 0xFF;			/* Priority level clearness					*/
	mov 0xFFFE9, #0xFF
	;***      165 : 	PR10H = 0xFF;			/* Priority level clearness					*/
	mov 0xFFFED, #0xFF
	;***      166 : 
	;***      167 : #ifdef DEVICE_R5F10Y4xASP
	;***      168 : 	MK1L = 0xFF;			/* All individual interrupt is prohibited	*/
	mov 0xFFFE6, #0xFF
	;***      169 : 	IF1L = 0x00;			/* Interrupt request flag all clearness		*/
	mov 0xFFFE2, #0x00
	;***      170 : 	PR01L = 0xFF;			/* Priority level clearness					*/
	mov 0xFFFEA, #0xFF
	;***      171 : 	PR11L = 0xFF;			/* Priority level clearness					*/
	mov 0xFFFEE, #0xFF
	;***      172 : #endif
	;***      173 : 
	;***      174 : 	EGP0 = 0x00;			/* External interrupt rising edge	*/
	mov 0xFFF38, #0x00
	;***      175 : 	EGN0 = 0x00;			/* External interrupt rising edge	*/
	mov 0xFFF39, #0x00
	ret
	;***      176 : }
