#CC-RL Compiler RL78 Assembler Source
#@  CC-RL Version : V1.08.00 [28 Nov 2018]
#@  Commmand :
#@   -cpu=S1
#@   -obj_path=.\obj\
#@   -asm_path=.\obj\
#@   -dev=C:\Program Files (x86)\Renesas Electronics\Applilet EZ PL for RL78 V2.20\Tools\BIN\..\..\Tools\DEV\DR5F10Y47.DVF
#@   -c
#@   -I C:\Program Files (x86)\Renesas Electronics\CS+\CC\CC-RL\V1.08.00\inc,.\include
#@   -Osize
#@   -pass_source
#@   src\systeminit.c
#@  compiled at Tue Jun 18 19:05:17 2019

	.PUBLIC _SystemInit
	.EXTERN _Clock_Init
	.EXTERN _PORT_Init
	.EXTERN _WDT_Init
	.EXTERN _INT_Init
	.PUBLIC _hdwinit

	.SECTION .text,TEXT
_SystemInit:
	.STACK _SystemInit = 4
	;***        1 : /*******************************************************************************
	;***        2 : * DISCLAIMER
	;***        3 : * This software is supplied by Renesas Electronics Corporation and is only
	;***        4 : * intended for use with Renesas products. No other uses are authorized. This
	;***        5 : * software is owned by Renesas Electronics Corporation and is protected under
	;***        6 : * all applicable laws, including copyright laws.
	;***        7 : * THIS SOFTWARE IS PROVIDED "AS IS" AND RENESAS MAKES NO WARRANTIES REGARDING
	;***        8 : * THIS SOFTWARE, WHETHER EXPRESS, IMPLIED OR STATUTORY, INCLUDING BUT NOT
	;***        9 : * LIMITED TO WARRANTIES OF MERCHANTABILITY, FITNESS FOR A PARTICULAR PURPOSE
	;***       10 : * AND NON-INFRINGEMENT. ALL SUCH WARRANTIES ARE EXPRESSLY DISCLAIMED.
	;***       11 : * TO THE MAXIMUM EXTENT PERMITTED NOT PROHIBITED BY LAW, NEITHER RENESAS
	;***       12 : * ELECTRONICS CORPORATION NOR ANY OF ITS AFFILIATED COMPANIES SHALL BE LIABLE
	;***       13 : * FOR ANY DIRECT, INDIRECT, SPECIAL, INCIDENTAL OR CONSEQUENTIAL DAMAGES FOR
	;***       14 : * ANY REASON RELATED TO THIS SOFTWARE, EVEN IF RENESAS OR ITS AFFILIATES HAVE
	;***       15 : * BEEN ADVISED OF THE POSSIBILITY OF SUCH DAMAGES.
	;***       16 : * Renesas reserves the right, without notice, to make changes to this software
	;***       17 : * and to discontinue the availability of this software. By using this software,
	;***       18 : * you agree to the additional terms and conditions found by accessing the
	;***       19 : * following link:
	;***       20 : * http://www.renesas.com/disclaimer
	;***       21 : *
	;***       22 : * Copyright (C) 2016 Renesas Electronics Corporation. All rights reserved.
	;***       23 : *******************************************************************************/
	;***       24 : 
	;***       25 : /*******************************************************************************
	;***       26 : * File Name    : systeminit.c
	;***       27 : * Version      : Applilet EZ PL for RL78
	;***       28 : * Device(s)    : R5F10Y14,R5F10Y16,R5F10Y17,R5F10Y44,R5F10Y46,R5F10Y47
	;***       29 : * Tool-Chain   : CC-RL
	;***       30 : * Description  : This file implements main function.
	;***       31 : * Creation Date: 2016/09/14
	;***       32 : *******************************************************************************/
	;***       33 : 
	;***       34 : /*******************************************************************************
	;***       35 : Includes <System Includes> , "Project Includes"
	;***       36 : *******************************************************************************/
	;***       37 : #include "sfr.h"
	;***       38 : #include "common.h"
	;***       39 : #include "config.h"
	;***       40 : #include "system.h"
	;***       41 : #include "int.h"
	;***       42 : #include "port.h"
	;***       43 : #include "timer.h"
	;***       44 : #include "watchdogtimer.h"
	;***       45 : 
	;***       46 : /*******************************************************************************
	;***       47 : Macro definitions
	;***       48 : *******************************************************************************/
	;***       49 : 
	;***       50 : /*******************************************************************************
	;***       51 : Typedef definitions
	;***       52 : *******************************************************************************/
	;***       53 : 
	;***       54 : /*******************************************************************************
	;***       55 : Imported global variables and functions (from other files)
	;***       56 : *******************************************************************************/
	;***       57 : 
	;***       58 : /*******************************************************************************
	;***       59 : Exported global variables and functions (to be accessed by other files)
	;***       60 : *******************************************************************************/
	;***       61 : 
	;***       62 : /*******************************************************************************
	;***       63 : Private variables and functions
	;***       64 : *******************************************************************************/
	;***       65 : 
	;***       66 : /*******************************************************************************
	;***       67 : * Function Name: SystemInit
	;***       68 : * Description  : This function initializes every Macro.
	;***       69 : * Arguments    : none
	;***       70 : * Return Value : none
	;***       71 : ********************************************************************************/
	;***       72 : void SystemInit( void )
	;***       73 : {
	;***       74 : 	/* Initialize the peripheral I/O Redirection registers */
	;***       75 : 	PIOR = 0x00;
	clrb !0x0077
	;***       76 : 
	;***       77 : 	/* Peripheral Enable Register initiate */
	;***       78 : 	PER0 = 0x00;
	clrb !0x00F0
	;***       79 : 
	;***       80 : 	/* Clock generator initiate */
	;***       81 : 	Clock_Init();
	call !_Clock_Init
	;***       82 : 	
	;***       83 : 	/* Port initiate */
	;***       84 : 	PORT_Init();
	call !_PORT_Init
	;***       85 : 	
	;***       86 : 	/* WDT initiate */
	;***       87 : 	WDT_Init();
	call !_WDT_Init
	;***       88 : 	
	;***       89 : 	/* INT initiate */
	;***       90 : 	INT_Init();
	br !_INT_Init
_hdwinit:
	.STACK _hdwinit = 4
	;***       91 : 	
	;***       92 : #if !defined PWM_USED
	;***       93 : 	/* TM00 initiate */
	;***       94 : 	TM00_Init();
	;***       95 : #endif /* end of defined PWM_USED */
	;***       96 : }
	;***       97 : 
	;***       98 : /*******************************************************************************
	;***       99 : * Function Name: hdwinit
	;***      100 : * Description  : This function initializes hardware settings.
	;***      101 : * Arguments    : none
	;***      102 : * Return Value : none
	;***      103 : ********************************************************************************/
	;***      104 : void hdwinit( void )
	;***      105 : {
	;***      106 : 	__DI( );
	di
	;***      107 : 	SystemInit( );
	call !_SystemInit
	;***      108 : 	__EI( );
	ei
	ret
	;***      109 : }
